set define off
set verify off
set feedback off
WHENEVER SQLERROR EXIT SQL.SQLCODE ROLLBACK
begin wwv_flow.g_import_in_progress := true; end;
/
 
--       AAAA       PPPPP   EEEEEE  XX      XX
--      AA  AA      PP  PP  EE       XX    XX
--     AA    AA     PP  PP  EE        XX  XX
--    AAAAAAAAAA    PPPPP   EEEE       XXXX
--   AA        AA   PP      EE        XX  XX
--  AA          AA  PP      EE       XX    XX
--  AA          AA  PP      EEEEEE  XX      XX
prompt  Set Credentials...
 
begin
 
  -- Assumes you are running the script connected to SQL*Plus as the Oracle user APEX_040200 or as the owner (parsing schema) of the application.
  wwv_flow_api.set_security_group_id(p_security_group_id=>nvl(wwv_flow_application_install.get_workspace_id,2342421528101415));
 
end;
/

begin wwv_flow.g_import_in_progress := true; end;
/
begin 

select value into wwv_flow_api.g_nls_numeric_chars from nls_session_parameters where parameter='NLS_NUMERIC_CHARACTERS';

end;

/
begin execute immediate 'alter session set nls_numeric_characters=''.,''';

end;

/
begin wwv_flow.g_browser_language := 'en'; end;
/
prompt  Check Compatibility...
 
begin
 
-- This date identifies the minimum version required to import this file.
wwv_flow_api.set_version(p_version_yyyy_mm_dd=>'2012.01.01');
 
end;
/

prompt  Set Application Offset...
 
begin
 
   -- SET APPLICATION OFFSET
   wwv_flow_api.g_id_offset := nvl(wwv_flow_application_install.get_offset,0);
null;
 
end;
/

 
begin
 
wwv_flow_api.remove_restful_service (
  p_id => 7449376171583311 + wwv_flow_api.g_id_offset
 ,p_name => 'document.source'
  );
 
null;
 
end;
/

prompt  ...restful service
--
--application/restful_services/document_source
 
begin
 
wwv_flow_api.create_restful_module (
  p_id => 7449376171583311 + wwv_flow_api.g_id_offset
 ,p_name => 'document.source'
 ,p_uri_prefix => 'source/'
 ,p_parsing_schema => 'RDM_OWNER'
 ,p_items_per_page => 25
 ,p_status => 'PUBLISHED'
  );
 
wwv_flow_api.create_restful_template (
  p_id => 7450279299490358 + wwv_flow_api.g_id_offset
 ,p_module_id => 7449376171583311 + wwv_flow_api.g_id_offset
 ,p_uri_template => 'getDoc/{id}'
 ,p_priority => 0
 ,p_etag_type => 'HASH'
  );
 
wwv_flow_api.create_restful_handler (
  p_id => 7450371643535492 + wwv_flow_api.g_id_offset
 ,p_template_id => 7450279299490358 + wwv_flow_api.g_id_offset
 ,p_source_type => 'MEDIA'
 ,p_format => 'DEFAULT'
 ,p_method => 'GET'
 ,p_require_https => 'NO'
 ,p_source => 
'select'||unistr('\000a')||
'  rdb_mime_tipas,'||unistr('\000a')||
'  rdb_turinys'||unistr('\000a')||
'from'||unistr('\000a')||
'  rdm_darbai'||unistr('\000a')||
'where '||unistr('\000a')||
'  rdb_id = :id'
  );
 
wwv_flow_api.create_restful_param (
  p_id => 7450479608537723 + wwv_flow_api.g_id_offset
 ,p_handler_id => 7450371643535492 + wwv_flow_api.g_id_offset
 ,p_name => 'ID'
 ,p_bind_variable_name => 'ID'
 ,p_source_type => 'HEADER'
 ,p_access_method => 'IN'
 ,p_param_type => 'STRING'
  );
 
wwv_flow_api.create_restful_template (
  p_id => 7449481337583314 + wwv_flow_api.g_id_offset
 ,p_module_id => 7449376171583311 + wwv_flow_api.g_id_offset
 ,p_uri_template => 'getList'
 ,p_priority => 0
 ,p_etag_type => 'HASH'
  );
 
wwv_flow_api.create_restful_handler (
  p_id => 7449553099586139 + wwv_flow_api.g_id_offset
 ,p_template_id => 7449481337583314 + wwv_flow_api.g_id_offset
 ,p_source_type => 'MEDIA'
 ,p_format => 'DEFAULT'
 ,p_method => 'GET'
 ,p_require_https => 'NO'
 ,p_source => 
'select'||unistr('\000a')||
'  ''application/json'' mime,'||unistr('\000a')||
'  rdm_ws.format_full_list_documents(:begin_date) content'||unistr('\000a')||
'from '||unistr('\000a')||
'  dual'
  );
 
wwv_flow_api.create_restful_param (
  p_id => 7449657601587497 + wwv_flow_api.g_id_offset
 ,p_handler_id => 7449553099586139 + wwv_flow_api.g_id_offset
 ,p_name => 'begin_date'
 ,p_bind_variable_name => 'begin_date'
 ,p_source_type => 'HEADER'
 ,p_access_method => 'IN'
 ,p_param_type => 'STRING'
  );
 
null;
 
end;
/

commit;
begin
execute immediate 'begin sys.dbms_session.set_nls( param => ''NLS_NUMERIC_CHARACTERS'', value => '''''''' || replace(wwv_flow_api.g_nls_numeric_chars,'''''''','''''''''''') || ''''''''); end;';
end;
/
set verify on
set feedback on
set define on
prompt  ...done
set define off
set verify off
set feedback off
WHENEVER SQLERROR EXIT SQL.SQLCODE ROLLBACK
begin wwv_flow.g_import_in_progress := true; end;
/
 
--       AAAA       PPPPP   EEEEEE  XX      XX
--      AA  AA      PP  PP  EE       XX    XX
--     AA    AA     PP  PP  EE        XX  XX
--    AAAAAAAAAA    PPPPP   EEEE       XXXX
--   AA        AA   PP      EE        XX  XX
--  AA          AA  PP      EE       XX    XX
--  AA          AA  PP      EEEEEE  XX      XX
prompt  Set Credentials...
 
begin
 
  -- Assumes you are running the script connected to SQL*Plus as the Oracle user APEX_040200 or as the owner (parsing schema) of the application.
  wwv_flow_api.set_security_group_id(p_security_group_id=>nvl(wwv_flow_application_install.get_workspace_id,2342421528101415));
 
end;
/

begin wwv_flow.g_import_in_progress := true; end;
/
begin 

select value into wwv_flow_api.g_nls_numeric_chars from nls_session_parameters where parameter='NLS_NUMERIC_CHARACTERS';

end;

/
begin execute immediate 'alter session set nls_numeric_characters=''.,''';

end;

/
begin wwv_flow.g_browser_language := 'en'; end;
/
prompt  Check Compatibility...
 
begin
 
-- This date identifies the minimum version required to import this file.
wwv_flow_api.set_version(p_version_yyyy_mm_dd=>'2012.01.01');
 
end;
/

prompt  Set Application Offset...
 
begin
 
   -- SET APPLICATION OFFSET
   wwv_flow_api.g_id_offset := nvl(wwv_flow_application_install.get_offset,0);
null;
 
end;
/

 
begin
 
wwv_flow_api.remove_restful_service (
  p_id => 7449376171583311 + wwv_flow_api.g_id_offset
 ,p_name => 'document.source'
  );
 
null;
 
end;
/

prompt  ...restful service
--
--application/restful_services/document_source
 
begin
 
wwv_flow_api.create_restful_module (
  p_id => 7449376171583311 + wwv_flow_api.g_id_offset
 ,p_name => 'document.source'
 ,p_uri_prefix => 'source/'
 ,p_parsing_schema => 'RDM_OWNER'
 ,p_items_per_page => 25
 ,p_status => 'PUBLISHED'
  );
 
wwv_flow_api.create_restful_template (
  p_id => 7450279299490358 + wwv_flow_api.g_id_offset
 ,p_module_id => 7449376171583311 + wwv_flow_api.g_id_offset
 ,p_uri_template => 'getDoc/{id}'
 ,p_priority => 0
 ,p_etag_type => 'HASH'
  );
 
wwv_flow_api.create_restful_handler (
  p_id => 7450371643535492 + wwv_flow_api.g_id_offset
 ,p_template_id => 7450279299490358 + wwv_flow_api.g_id_offset
 ,p_source_type => 'MEDIA'
 ,p_format => 'DEFAULT'
 ,p_method => 'GET'
 ,p_require_https => 'NO'
 ,p_source => 
'select'||unistr('\000a')||
'  rdb_mime_tipas,'||unistr('\000a')||
'  rdb_turinys'||unistr('\000a')||
'from'||unistr('\000a')||
'  rdm_darbai'||unistr('\000a')||
'where '||unistr('\000a')||
'  rdb_id = :id'
  );
 
wwv_flow_api.create_restful_param (
  p_id => 7450479608537723 + wwv_flow_api.g_id_offset
 ,p_handler_id => 7450371643535492 + wwv_flow_api.g_id_offset
 ,p_name => 'ID'
 ,p_bind_variable_name => 'ID'
 ,p_source_type => 'HEADER'
 ,p_access_method => 'IN'
 ,p_param_type => 'STRING'
  );
 
wwv_flow_api.create_restful_template (
  p_id => 7449481337583314 + wwv_flow_api.g_id_offset
 ,p_module_id => 7449376171583311 + wwv_flow_api.g_id_offset
 ,p_uri_template => 'getList'
 ,p_priority => 0
 ,p_etag_type => 'HASH'
  );
 
wwv_flow_api.create_restful_handler (
  p_id => 7449553099586139 + wwv_flow_api.g_id_offset
 ,p_template_id => 7449481337583314 + wwv_flow_api.g_id_offset
 ,p_source_type => 'MEDIA'
 ,p_format => 'DEFAULT'
 ,p_method => 'GET'
 ,p_require_https => 'NO'
 ,p_source => 
'select'||unistr('\000a')||
'  ''application/json'' mime,'||unistr('\000a')||
'  rdm_ws.format_full_list_documents(:begin_date) content'||unistr('\000a')||
'from '||unistr('\000a')||
'  dual'
  );
 
wwv_flow_api.create_restful_param (
  p_id => 7449657601587497 + wwv_flow_api.g_id_offset
 ,p_handler_id => 7449553099586139 + wwv_flow_api.g_id_offset
 ,p_name => 'begin_date'
 ,p_bind_variable_name => 'begin_date'
 ,p_source_type => 'HEADER'
 ,p_access_method => 'IN'
 ,p_param_type => 'STRING'
  );
 
null;
 
end;
/

commit;
begin
execute immediate 'begin sys.dbms_session.set_nls( param => ''NLS_NUMERIC_CHARACTERS'', value => '''''''' || replace(wwv_flow_api.g_nls_numeric_chars,'''''''','''''''''''') || ''''''''); end;';
end;
/
set verify on
set feedback on
set define on
prompt  ...done
