create or replace function funcTSec return boolean is
begin
    PLOG.error ('error in funcTSec');
    return true;    
end;    
/

create or replace package ptSec is
    procedure ptSecPrc;
end;
/

create or replace package body ptSec is
    procedure ptSecPrc is
        r boolean;
    begin
        PLOG.error ('error in ptSec');
        r := funcTSec;
    end;    
end;
/

Exec PLOG.purge;
Exec ptSec.ptSecPrc; 


select  LSECTION||'->'||LTEXT         from  tlog;

/*
SQL> select  LSECTION||'->'||LTEXT         from  tlog;

LSECTION||'->'||LTEXT
--------------------------------------------------------------------------------
plog.purge->Purge By SCOTT
block.SCOTT.PTSEC->error in ptSec
block.SCOTT.PTSEC.SCOTT.FUNCTSEC->error in funcTSec
*/


create or replace procedure procTSec (cpt number default 0) is
    pCTX PLOGPARAM.LOG_CTX := PLOG.init(pLEVEL       => PLOG.LDEBUG);
begin
    PLOG.INFO (pCTX,  cpt);
    if cpt < 10 then
        procTSec ( cpt + 1 );
    end if;
end;    
/

Exec PLOG.purge;
Exec procTSec; 

set linesize 4000
set pagesize 1000
select LTEXT||'-'||length(LSECTION)||'-'||LSECTION  from  tlog;

/*
SQL>  select LTEXT||'-'||length(LSECTION)||'-'||LSECTION  from  tlog;

LTEXT||'-'||LENGTH(LSECTION)||'-'||LSECTION

Purge by user:SCOTT-10-plog.purge
0-20-block.SCOTT.PROCTSEC
1-35-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC
2-50-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC
3-65-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC
4-80-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC
5-95-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC

LTEXT||'-'||LENGTH(LSECTION)||'-'||LSECTION

6-110-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC
7-125-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.S
8-140-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.S
9-155-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.S
10-170-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.
11-185-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.
12-200-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.

LTEXT||'-'||LENGTH(LSECTION)||'-'||LSECTION

13-215-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.
14-230-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.
15-245-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.
16-260-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.
17-275-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.
18-290-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.
19-305-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.

LTEXT||'-'||LENGTH(LSECTION)||'-'||LSECTION

20-320-block.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.SCOTT.PROCTSEC.

*/


