rem ---------------------------------------------------------------------------------
rem Rašto darbų mainavietės duomenų bazės objektų sukūrimo SQL komandinis 
rem failas
rem Autorius: Žilvinas Liaugaudas (UAB Affecto Lietuva)
rem Data: 2013-08-06
rem Modifikacijos (kada, kas, ką):
rem
rem ---------------------------------------------------------------------------------

set echo off
set verify off
set serveroutput on
set pagesize 0

rem ---------------------------------------------------------------------------------
rem Apibrėžiame pagrindinius sistemos parametrus
rem ---------------------------------------------------------------------------------

@@defines.sql

rem ---------------------------------------------------------------------------------
rem Apibrėžiame išvestinius sistemos parametrus
rem ---------------------------------------------------------------------------------

set feedback on
spool install.log

rem ---------------------------------------------------------------------------------
rem Sukuriame lentelių erdves
rem ---------------------------------------------------------------------------------

@@create_tablespaces.sql


rem ---------------------------------------------------------------------------------
rem Sukuriame Oracle DB naudotoją - sistemos duomenų bazės objektų savininką
rem ---------------------------------------------------------------------------------

@@create_owner.sql

rem ---------------------------------------------------------------------------------
rem Sutvarkome ACL
rem ---------------------------------------------------------------------------------

@@create_acl.sql

prompt connect by "&owner_username" ...
connect &owner_username@&owner_sid/&owner_password

set echo off
set verify off
set pagesize 0

whenever sqlerror exit failure
begin
  if user != upper('&owner_username') then
    raise_application_error(-20000, 'Nepavyko prisijungti prie duomenų bazės naudotoju "&owner_username"');
  end if;
end;
/

whenever sqlerror continue

@@create_tables.sql
@@create_indexes.sql
@@create_constraints.sql
@@create_sequences.sql

@@create_types.sql

set scan off

@@create_packages1.sql
@@create_packages2.sql

set scan on

@@create_procedure.sql
@@create_jobs.sql


@@setup_parameters.sql
@@ins_cg_ref_codes.sql

spool off
quit

rem ---------------------------------------------------------------------------------
rem Failo pabaiga
rem ---------------------------------------------------------------------------------

